git-stash.sh 4.1 KB
Newer Older
しらいしななこ 已提交
1 2 3 4 5
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

USAGE='[ | list | show | apply | clear]'

6
SUBDIRECTORY_OK=Yes
しらいしななこ 已提交
7 8
. git-sh-setup
require_work_tree
9
cd_to_toplevel
しらいしななこ 已提交
10 11 12 13 14 15 16

TMP="$GIT_DIR/.git-stash.$$"
trap 'rm -f "$TMP-*"' 0

ref_stash=refs/stash

no_changes () {
17 18
	git diff-index --quiet --cached HEAD &&
	git diff-files --quiet
しらいしななこ 已提交
19 20 21 22 23 24 25 26 27
}

clear_stash () {
	logfile="$GIT_DIR/logs/$ref_stash" &&
	mkdir -p "$(dirname "$logfile")" &&
	: >"$logfile"
}

save_stash () {
28 29
	stash_msg="$1"

しらいしななこ 已提交
30 31 32 33 34 35 36 37 38
	if no_changes
	then
		echo >&2 'No local changes to save'
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	# state of the base commit
39
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ 已提交
40
	then
41
		head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
しらいしななこ 已提交
42 43 44 45
	else
		die "You do not have the initial commit yet"
	fi

46
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ 已提交
47 48 49 50 51 52 53 54
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
55
	i_tree=$(git write-tree) &&
しらいしななこ 已提交
56
	i_commit=$(printf 'index on %s' "$msg" |
57
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ 已提交
58 59 60 61
		die "Cannot save the current index state"

	# state of the working tree
	w_tree=$( (
62 63
		rm -f "$TMP-index" &&
		cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
しらいしななこ 已提交
64 65
		GIT_INDEX_FILE="$TMP-index" &&
		export GIT_INDEX_FILE &&
66
		git read-tree -m $i_tree &&
67 68
		git add -u &&
		git write-tree &&
しらいしななこ 已提交
69 70 71 72 73
		rm -f "$TMP-index"
	) ) ||
		die "Cannot save the current worktree state"

	# create the stash
74 75 76 77 78 79 80
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
81
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ 已提交
82 83
		die "Cannot record working tree state"

84
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ 已提交
85
		die "Cannot save the current status"
86
	printf >&2 'Saved "%s"\n' "$stash_msg"
しらいしななこ 已提交
87 88
}

89
have_stash () {
90
	git rev-parse --verify $ref_stash >/dev/null 2>&1
91 92
}

しらいしななこ 已提交
93
list_stash () {
94
	have_stash || return 0
95
	git log --pretty=oneline -g "$@" $ref_stash |
しらいしななこ 已提交
96 97 98 99
	sed -n -e 's/^[.0-9a-f]* refs\///p'
}

show_stash () {
100
	flags=$(git rev-parse --no-revs --flags "$@")
しらいしななこ 已提交
101 102 103 104
	if test -z "$flags"
	then
		flags=--stat
	fi
105
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
しらいしななこ 已提交
106

107 108 109
	w_commit=$(git rev-parse --verify "$s") &&
	b_commit=$(git rev-parse --verify "$s^") &&
	git diff $flags $b_commit $w_commit
しらいしななこ 已提交
110 111 112
}

apply_stash () {
113
	git diff-files --quiet ||
しらいしななこ 已提交
114 115
		die 'Cannot restore on top of a dirty state'

116 117 118 119 120 121 122
	unstash_index=
	case "$1" in
	--index)
		unstash_index=t
		shift
	esac

しらいしななこ 已提交
123
	# current index state
124
	c_tree=$(git write-tree) ||
しらいしななこ 已提交
125 126
		die 'Cannot apply a stash in the middle of a merge'

127 128 129
	s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
	w_tree=$(git rev-parse --verify "$s:") &&
	b_tree=$(git rev-parse --verify "$s^:") ||
しらいしななこ 已提交
130 131
		die "$*: no valid stashed state found"

132 133 134 135 136 137 138 139 140
	test -z "$unstash_index" || {
		git diff --binary $s^2^..$s^2 | git apply --cached
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
		unstashed_index_tree=$(git-write-tree) ||
			die 'Could not save index tree'
		git reset
	}

しらいしななこ 已提交
141 142 143 144 145 146 147 148 149 150 151
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

	if git-merge-recursive $b_tree -- $c_tree $w_tree
	then
		# No conflict
		a="$TMP-added" &&
152 153 154
		git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
		git read-tree --reset $c_tree &&
		git update-index --add --stdin <"$a" ||
しらいしななこ 已提交
155 156 157
			die "Cannot unstage modified files"
		git-status
		rm -f "$a"
158
		test -z "$unstash_index" || git read-tree $unstashed_index_tree
しらいしななこ 已提交
159 160
	else
		# Merge conflict; keep the exit status from merge-recursive
161 162 163
		status=$?
		test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
		exit $status
しらいしななこ 已提交
164 165 166 167 168
	fi
}

# Main command set
case "$1" in
169 170
list)
	shift
しらいしななこ 已提交
171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188
	if test $# = 0
	then
		set x -n 10
		shift
	fi
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
apply)
	shift
	apply_stash "$@"
	;;
clear)
	clear_stash
	;;
189 190
help | usage)
	usage
しらいしななこ 已提交
191 192
	;;
*)
193 194 195 196 197 198
	if test $# -gt 0 && test "$1" = save
	then
		shift
	fi
	save_stash "$*" && git-reset --hard
	;;
しらいしななこ 已提交
199
esac